/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, markType, INotifyPropertyChanged_$type, PropertyChangedEventArgs, runOn, delegateCombine, enumGetBox, typeCast, delegateRemove, fromEn, EnumUtil } from "igniteui-react-core";
import { RenderingContext } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { ToolPanel } from "./ToolPanel";
import { DOMExecutionContext } from "igniteui-react-core";
import { CanvasViewRenderer } from "igniteui-react-core";
import { Size } from "igniteui-react-core";
import { NativeUI } from "igniteui-react-core";
import { FontUtil } from "igniteui-react-core";
import { ICommandStateChangedListener_$type } from "igniteui-react-core";
import { SRProvider } from "igniteui-react-core";
import { BaseControlTheme_$type } from "igniteui-react-core";
import { ToolActionCollection } from "./ToolActionCollection";
import { ToolbarOrientation_$type } from "./ToolbarOrientation";
import { ToolbarIconManager } from "./ToolbarIconManager";
import { ToolAction } from "./ToolAction";
import { NativeUIInputsFactory } from "igniteui-react-core";
import { NativeUIXInputsFactory } from "igniteui-react-inputs";
import { Visibility_$type } from "igniteui-react-core";
import { stringIsNullOrEmpty } from "igniteui-react-core";
/**
 * @hidden
 */
export let ToolbarView = /*@__PURE__*/ (() => {
    class ToolbarView extends Base {
        constructor() {
            super();
            this.n = null;
            this.m = null;
            this.a = null;
            this.i = null;
            this.l = null;
            this.e = null;
            this.k = null;
            this.b = ((() => {
                let $ret = new FontInfo();
                $ret.n = "Verdana";
                $ret.d = 13;
                $ret.q = "Normal";
                $ret.s = "Normal";
                $ret.o = "Normal";
                return $ret;
            })());
            this.aa = new Size();
            this.c = null;
            this._gridExternal = null;
            this.f = false;
            this.j = null;
        }
        p() {
            return this.i;
        }
        v() {
        }
        t(a) {
            if (a == null) {
                this.i = null;
                return;
            }
            this.a.a = new DOMExecutionContext(a);
            this.i = a;
            this.l = this.i.createElement("canvas");
            this.e = new RenderingContext(new CanvasViewRenderer(), this.i.get2DCanvasContext(this.l));
            this.k = this.i.createElement("div");
            this.y();
            let b = new ToolPanel();
            let c = this.i.createElement("div");
            c.setStyleProperty("width", "100%");
            c.setStyleProperty("height", "100%");
            this.i.append(c);
            let d = this.i.getSubRenderer(c);
            b.provideContainer(d);
            let e = this.i.getExternal(b, this.i.rootWrapper, this.i.getExternal(this.a, null, null));
            this.a.b2(b);
            let f = Math.round(a.rootWrapper.width());
            let g = Math.round(a.rootWrapper.height());
            this.i.rootWrapper.setStyleProperty("position", "relative");
        }
        y() {
        }
        x() {
            if (this.i != null) {
            }
        }
        s() {
            if (this.i == null) {
                return;
            }
            let a = this.i.rootWrapper.width();
            let b = this.i.rootWrapper.height();
            this.aa = new Size(1, a, b);
            this.a.b5(this.aa);
        }
        z() {
            let a = this.i;
            if (null == a) {
                return;
            }
            let b = a.rootWrapper;
            if (null != b) {
                NativeUI.p(b, this.a.cz);
                NativeUI.l(b, this.a.cq);
            }
        }
        d() {
            return this.b;
        }
        u() {
        }
        w() {
        }
        r() {
        }
        g() {
            return this.aa.width;
        }
        h(a) {
            this.c = this.a.s();
            return FontUtil.measureStringWidth(a, this.c, this.e);
        }
        q(a, b) {
            if (this.j == null) {
                this.j = this.i.createElement("div");
            }
            b(this.j.getNativeElement());
        }
    }
    ToolbarView.$t = /*@__PURE__*/ markType(ToolbarView, 'ToolbarView');
    return ToolbarView;
})();
/**
 * @hidden
 */
export let Toolbar = /*@__PURE__*/ (() => {
    class Toolbar extends Base {
        constructor() {
            super();
            this.k = null;
            this.v = false;
            this.t = null;
            this.m = null;
            this.n = 0;
            this.d = new ToolActionCollection();
            this.b = new ToolActionCollection();
            this.c = new ToolActionCollection();
            this.h = Toolbar.i;
            this.p = null;
            this.av = Toolbar.aw;
            this.ce = null;
            this.cm = null;
            this.cg = null;
            this.cl = null;
            this.ci = null;
            this.cn = null;
            this.cf = null;
            this.ch = null;
            this.cp = null;
            this.co = null;
            this.aj = NaN;
            this.ak = NaN;
            this.cj = null;
            this.ck = null;
            this.q = null;
            this.ag = NaN;
            this.ah = NaN;
            this.ai = NaN;
            this.af = NaN;
            this.ac = NaN;
            this.ad = NaN;
            this.ae = NaN;
            this.ab = NaN;
            this.x = true;
            this.w = false;
            this.propertyChanged = null;
            this.a = null;
            this.onCommand = null;
            ToolbarIconManager.c();
            let a = this.actions;
            a.collectionChanged = delegateCombine(a.collectionChanged, runOn(this, this.bu));
            let b = this.actualActions;
            b.collectionChanged = delegateCombine(b.collectionChanged, runOn(this, this.bw));
            let c = this.actualActions;
            c.collectionResetting = delegateCombine(c.collectionResetting, runOn(this, this.bx));
            NativeUIInputsFactory.n();
            NativeUIXInputsFactory.j();
            let d = new ToolbarView();
            d.a = this;
            this.k = d;
            this.k.v();
        }
        get u() {
            if (this.t == null) {
                this.t = new SRProvider(this.k.i);
                this.t.cb("Layouts");
            }
            return this.t;
        }
        b2(a) {
            this.m = a;
            this.m.r = this.n == 0 ? 1 : this.n;
            let b = this.m;
            b.onCommand = delegateCombine(b.onCommand, runOn(this, this.bt));
            this.m.o = this.j;
            this.m.ac = this.aa;
            this.m.fh = this.cz;
            this.m.e8 = this.cr;
            this.m.e7 = this.cq;
            this.m.fg = this.cy;
            this.m.e9 = this.cs;
            this.m.fb = this.ct;
            this.m.ff = this.cx;
            this.m.fc = this.cu;
            this.m.fj = this.c1;
            this.m.fi = this.c0;
            this.m.bl = this.at;
            this.m.bm = this.au;
            this.m.fd = this.cv;
            this.m.fe = this.cw;
            this.m.be = this.am;
            this.m.bf = this.an;
            this.m.bg = this.ao;
            this.m.bd = this.al;
            this.m.bi = this.aq;
            this.m.bj = this.ar;
            this.m.bk = this.as;
            this.m.bh = this.ap;
        }
        bt(a, b) {
            if (this.onCommand != null) {
                this.onCommand(this, b);
            }
            if (this.p != null) {
                this.p.onToolCommandExecuting(b.a);
            }
        }
        b5(a) {
            this.m.notifySizeChanged();
        }
        get o() {
            return this.n;
        }
        set o(a) {
            let b = this.n;
            this.n = a;
            if (b != this.n) {
                this.b6("BaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, a));
            }
        }
        get autoGeneratedActions() {
            return this.d;
        }
        set autoGeneratedActions(a) {
            let b = this.d;
            this.d = a;
            if (b != this.d) {
                this.b6("AutoGeneratedActions", b, this.d);
            }
        }
        get actions() {
            return this.b;
        }
        set actions(a) {
            let b = this.b;
            this.b = a;
            if (b != this.b) {
                this.b6("Actions", b, this.b);
            }
        }
        get actualActions() {
            return this.c;
        }
        set actualActions(a) {
            let b = this.c;
            this.c = a;
            if (b != this.c) {
                this.b6("ActualActions", b, this.c);
            }
        }
        get j() {
            return this.h;
        }
        set j(a) {
            let b = this.h;
            this.h = a;
            if (b != this.h) {
                this.b6("Orientation", enumGetBox(ToolbarOrientation_$type, b), enumGetBox(ToolbarOrientation_$type, a));
            }
        }
        get target() {
            return this.av;
        }
        set target(a) {
            let b = this.av;
            this.av = a;
            if (b != this.av) {
                this.b6("Target", b, a);
            }
        }
        get cq() {
            return this.ce;
        }
        set cq(a) {
            let b = this.ce;
            this.ce = a;
            if (b != this.ce) {
                this.b6("BackgroundColor", b, a);
            }
        }
        get cy() {
            return this.cm;
        }
        set cy(a) {
            let b = this.cm;
            this.cm = a;
            if (b != this.cm) {
                this.b6("SubmenuBackgroundColor", b, this.cm);
            }
        }
        get cs() {
            return this.cg;
        }
        set cs(a) {
            let b = this.cg;
            this.cg = a;
            if (b != this.cg) {
                this.b6("GroupHeaderBackgroundColorPropertyName", b, this.cg);
            }
        }
        get cx() {
            return this.cl;
        }
        set cx(a) {
            let b = this.cl;
            this.cl = a;
            if (b != this.cl) {
                this.b6("SeparatorBackgroundColor", b, this.cl);
            }
        }
        get cu() {
            return this.ci;
        }
        set cu(a) {
            let b = this.ci;
            this.ci = a;
            if (b != this.ci) {
                this.b6("HoverBackgroundColor", b, this.ci);
            }
        }
        get cz() {
            return this.cn;
        }
        set cz(a) {
            let b = this.cn;
            this.cn = a;
            if (b != this.cn) {
                this.b6("TextColor", b, this.cn);
            }
        }
        get cr() {
            return this.cf;
        }
        set cr(a) {
            let b = this.cf;
            this.cf = a;
            if (b != this.cf) {
                this.b6("DisabledTextColor", b, this.cf);
            }
        }
        get ct() {
            return this.ch;
        }
        set ct(a) {
            let b = this.ch;
            this.ch = a;
            if (b != this.ch) {
                this.b6("GroupHeaderTextColor", b, this.ch);
            }
        }
        get c1() {
            return this.cp;
        }
        set c1(a) {
            let b = this.cp;
            this.cp = a;
            if (b != this.cp) {
                this.b6("ToolTipTextColor", b, this.cp);
            }
        }
        get c0() {
            return this.co;
        }
        set c0(a) {
            let b = this.co;
            this.co = a;
            if (b != this.co) {
                this.b6("ToolTipBackgroundColor", b, this.co);
            }
        }
        get at() {
            return this.aj;
        }
        set at(a) {
            let b = this.aj;
            this.aj = a;
            if (b != this.aj) {
                this.b6("ToolTipCornerRadius", b, this.aj);
            }
        }
        get au() {
            return this.ak;
        }
        set au(a) {
            let b = this.ak;
            this.ak = a;
            if (b != this.ak) {
                this.b6("ToolTipElevation", b, this.ak);
            }
        }
        get cv() {
            return this.cj;
        }
        set cv(a) {
            let b = this.cj;
            this.cj = a;
            if (b != this.cj) {
                this.b6("IconFill", b, this.cj);
            }
        }
        get cw() {
            return this.ck;
        }
        set cw(a) {
            let b = this.ck;
            this.ck = a;
            if (b != this.ck) {
                this.b6("IconStroke", b, this.ck);
            }
        }
        get r() {
            return this.q;
        }
        set r(a) {
            let b = this.q;
            this.q = a;
            if (b != this.q) {
                this.b6("CellTextStyle", b, this.q);
            }
        }
        s() {
            if (this.r == null) {
                return this.k.d();
            }
            return this.r;
        }
        get aq() {
            return this.ag;
        }
        set aq(a) {
            let b = this.ag;
            this.ag = a;
            if (b != this.ag) {
                this.b6("SeparatorVerticalPaddingLeft", b, this.ag);
            }
        }
        get ar() {
            return this.ah;
        }
        set ar(a) {
            let b = this.ah;
            this.ah = a;
            if (b != this.ah) {
                this.b6("SeparatorVerticalPaddingRight", b, this.ah);
            }
        }
        get as() {
            return this.ai;
        }
        set as(a) {
            let b = this.ai;
            this.ai = a;
            if (b != this.ai) {
                this.b6("SeparatorVerticalPaddingTop", b, this.ai);
            }
        }
        get ap() {
            return this.af;
        }
        set ap(a) {
            let b = this.af;
            this.af = a;
            if (b != this.af) {
                this.b6("SeparatorVerticalPaddingBottom", b, this.af);
            }
        }
        get am() {
            return this.ac;
        }
        set am(a) {
            let b = this.ac;
            this.ac = a;
            if (b != this.ac) {
                this.b6("SeparatorHorizontalPaddingLeft", b, this.ac);
            }
        }
        get an() {
            return this.ad;
        }
        set an(a) {
            let b = this.ad;
            this.ad = a;
            if (b != this.ad) {
                this.b6("SeparatorHorizontalPaddingRight", b, this.ad);
            }
        }
        get ao() {
            return this.ae;
        }
        set ao(a) {
            let b = this.ae;
            this.ae = a;
            if (b != this.ae) {
                this.b6("SeparatorHorizontalPaddingTop", b, this.ae);
            }
        }
        get al() {
            return this.ab;
        }
        set al(a) {
            let b = this.ab;
            this.ab = a;
            if (b != this.ab) {
                this.b6("SeparatorHorizontalPaddingBottom", b, this.ab);
            }
        }
        get aa() {
            return this.x;
        }
        set aa(a) {
            let b = this.x;
            this.x = a;
            if (b != this.x) {
                this.b6("ShowOnHover", b, this.x);
            }
        }
        bu(a, b) {
            if (b.oldItems != null) {
                for (let c of fromEn(b.oldItems)) {
                    if (typeCast(INotifyPropertyChanged_$type, c) !== null) {
                        let d = c;
                        d.propertyChanged = delegateRemove(d.propertyChanged, runOn(this, this.bv));
                    }
                }
            }
            if (b.newItems != null) {
                for (let e of fromEn(b.newItems)) {
                    if (typeCast(INotifyPropertyChanged_$type, e) !== null) {
                        let f = e;
                        f.propertyChanged = delegateCombine(f.propertyChanged, runOn(this, this.bv));
                    }
                }
            }
            this.b4();
        }
        bw(a, b) {
            this.cd();
        }
        bx(a, b) {
            for (let c = 0; c < this.actualActions.count; c++) {
                if (typeCast(INotifyPropertyChanged_$type, this.actualActions._inner[c]) !== null) {
                    let d = this.actualActions._inner[c];
                    d.propertyChanged = delegateRemove(d.propertyChanged, runOn(this, this.bv));
                }
                this.actualActions._inner[c].b = null;
            }
        }
        cd() {
            let a = this.o == 0 ? 1 : this.o;
            if (this.m != null) {
                this.m.r = a;
            }
            for (let b = 0; b < this.actualActions.count; b++) {
                this.actualActions._inner[b].l = a;
            }
        }
        bv(a, b) {
        }
        b4() {
            this.ca();
        }
        ca() {
            if (this.w) {
                return;
            }
            this.w = true;
            this.a.enqueueAction(runOn(this, this.b0));
        }
        b0() {
            if (!this.w) {
                return;
            }
            this.w = false;
            this.cb();
            if (this.m.actions != this.actualActions) {
                this.m.actions = this.actualActions;
            }
        }
        cb() {
            this.actualActions.clear();
            for (let a = 0; a < this.autoGeneratedActions.count; a++) {
                this.actualActions.add(this.autoGeneratedActions._inner[a]);
            }
            let b = null;
            let c = null;
            let d = false;
            let e = false;
            let f = -1;
            let g = 0;
            for (let h = 0; h < this.actions.count; h++) {
                let i = this.actions._inner[h];
                if (!stringIsNullOrEmpty(i.cw)) {
                    if (((() => { let j = this.y(i.cw, this.actualActions, b, f); b = j.p2; f = j.p3; return j.ret; })())) {
                        b._inner[f].d2(i);
                    }
                }
                else {
                    if (!stringIsNullOrEmpty(i.b9)) {
                        if (i.d != null) {
                            i.d.actions.remove(i);
                        }
                        if (((() => { let j = this.y(i.b9, this.actualActions, b, f); b = j.p2; f = j.p3; return j.ret; })())) {
                            c = i.b9;
                            d = true;
                            e = false;
                        }
                    }
                    else if (!stringIsNullOrEmpty(i.b6)) {
                        if (i.d != null) {
                            i.d.actions.remove(i);
                        }
                        if (((() => { let j = this.y(i.b6, this.actualActions, b, f); b = j.p2; f = j.p3; return j.ret; })())) {
                            c = i.b6;
                            d = false;
                            e = true;
                            g = 0;
                        }
                    }
                    if (!stringIsNullOrEmpty(c)) {
                        if (d) {
                            b.insert(f, i);
                            f++;
                        }
                        else if (e) {
                            b.insert(f + 1 + g, i);
                            g++;
                        }
                    }
                    else {
                        this.actualActions.add(i);
                    }
                }
            }
        }
        y(a, b, c, d) {
            for (let e = 0; e < b.count; e++) {
                let f = b._inner[e];
                if (f.cu != null && f.cu == a) {
                    c = b;
                    d = e;
                    return {
                        ret: true,
                        p2: c,
                        p3: d
                    };
                }
                if (f.actions.count > 0) {
                    if (((() => { let g = this.y(a, f.actions, c, d); c = g.p2; d = g.p3; return g.ret; })())) {
                        return {
                            ret: true,
                            p2: c,
                            p3: d
                        };
                    }
                }
            }
            c = c;
            d = d;
            return {
                ret: false,
                p2: c,
                p3: d
            };
        }
        z(a, b, c, d) {
            for (let e = 0; e < b.count; e++) {
                let f = b._inner[e];
                if (f.cd == null) {
                    if (f.cu != null && f.cu == a) {
                        c = b;
                        d = e;
                        return {
                            ret: true,
                            p2: c,
                            p3: d
                        };
                    }
                }
                else if (f.cd != null && f.cd == a) {
                    c = b;
                    d = e;
                    return {
                        ret: true,
                        p2: c,
                        p3: d
                    };
                }
                if (f.actions.count > 0) {
                    if (((() => { let g = this.y(a, f.actions, c, d); c = g.p2; d = g.p3; return g.ret; })())) {
                        return {
                            ret: true,
                            p2: c,
                            p3: d
                        };
                    }
                }
            }
            c = c;
            d = d;
            return {
                ret: false,
                p2: c,
                p3: d
            };
        }
        b1() {
            if (this.w) {
                this.b0();
            }
        }
        notifySizeChanged() {
            this.k.s();
        }
        destroy() {
            this.provideContainer(null);
        }
        provideContainer(a) {
            this.k.t(a);
        }
        b6(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.b8(a, b, c);
        }
        b8(a, b, c) {
            switch (a) {
                case "CellTextStyle":
                    this.ca();
                    break;
                case "BackgroundColor":
                case "TextColor":
                case "SubmenuBackgroundColor":
                case "GroupHeaderBackgroundColorPropertyName":
                case "GroupHeaderTextColor":
                case "SeparatorBackgroundColor":
                case "HoverBackgroundColor":
                case "IconFill":
                case "IconStroke":
                case "ToolTipTextColor":
                case "ToolTipBackgroundColor":
                case "ToolTipCornerRadius":
                case "ToolTipElevation":
                case "Orientation":
                case "ShowOnHover":
                    this.cc();
                    break;
                case "Target":
                    let d = c;
                    let e = b;
                    this.b7(e, d);
                    break;
                case "BaseTheme":
                    this.cd();
                    break;
            }
        }
        cc() {
            if (this.m != null) {
                this.m.ac = this.aa;
                this.m.e7 = this.cq;
                this.m.fh = this.cz;
                this.m.e8 = this.cr;
                this.m.fg = this.cy;
                this.m.e9 = this.cs;
                this.m.fb = this.ct;
                this.m.ff = this.cx;
                this.m.fc = this.cu;
                this.m.o = this.j;
                this.m.fj = this.c1;
                this.m.fi = this.c0;
                this.m.bl = this.at;
                this.m.bm = this.au;
                this.m.fd = this.cv;
                this.m.fe = this.cw;
                this.m.be = this.am;
                this.m.bf = this.an;
                this.m.bg = this.ao;
                this.m.bd = this.al;
                this.m.bi = this.aq;
                this.m.bj = this.ar;
                this.m.bk = this.as;
                this.m.bh = this.ap;
            }
        }
        b7(a, b) {
            this.p = b;
            if (a != null) {
                this.autoGeneratedActions.clear();
                a.removeCommandStateChangedListener(this);
                this.ca();
            }
            if (b != null) {
                this.autoGeneratedActions.clear();
                let c = b.getDesiredToolbarActions();
                if (c != null) {
                    for (let d = 0; d < c.length; d++) {
                        let e = ToolAction.c(c[d]);
                        this.autoGeneratedActions.add(e);
                    }
                }
                b.addCommandStateChangedListener(this);
                this.ca();
            }
        }
        by() {
            if (this.m != null) {
                this.m.dc();
            }
        }
        onCommandStateChanged(a, b, c) {
            let d = null;
            let e = -1;
            if (((() => { let f = this.z(a, this.actualActions, d, e); d = f.p2; e = f.p3; return f.ret; })())) {
                let f = d._inner[e];
                switch (b) {
                    case 2:
                        switch (f.m) {
                            case 2:
                                f.e3 = c;
                                break;
                            case 5:
                                f.e4 = c;
                                break;
                            case 6:
                                f.e3 = c;
                                break;
                        }
                        break;
                    case 0:
                        f.e0 = EnumUtil.getEnumValue(Visibility_$type, c);
                        break;
                    case 1:
                        f.ah = c;
                        break;
                }
            }
        }
    }
    Toolbar.$t = /*@__PURE__*/ markType(Toolbar, 'Toolbar', Base.$, [INotifyPropertyChanged_$type, ICommandStateChangedListener_$type]);
    Toolbar.i = 1;
    Toolbar.aw = null;
    return Toolbar;
})();
