import { IgrToolAction } from "./igr-tool-action";
import { ToolActionIconButton } from "./ToolActionIconButton";
export class IgrToolActionIconButton extends IgrToolAction {
    createImplementation() {
        return new ToolActionIconButton();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor(props) {
        super(props);
    }
    /**
     * Gets or sets how long it takes before the tooltip is displayed (in milliseconds).
    */
    get tooltipDelay() {
        return this.i.fi;
    }
    set tooltipDelay(v) {
        this.i.fi = +v;
    }
    cleanUp() {
        this.i.dd();
    }
    openSubMenu() {
        this.i.d1();
    }
    closeSubmenu() {
        this.i.df();
    }
    fromInfo(info) {
        this.i.dp(info);
    }
}
