import { __extends } from "tslib";
import { IgrToolAction } from "./igr-tool-action";
import { ToolActionIconButton } from "./ToolActionIconButton";
var IgrToolActionIconButton = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrToolActionIconButton, _super);
    function IgrToolActionIconButton(props) {
        return _super.call(this, props) || this;
    }
    IgrToolActionIconButton.prototype.createImplementation = function () {
        return new ToolActionIconButton();
    };
    Object.defineProperty(IgrToolActionIconButton.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionIconButton.prototype, "tooltipDelay", {
        /**
         * Gets or sets how long it takes before the tooltip is displayed (in milliseconds).
        */
        get: function () {
            return this.i.fi;
        },
        set: function (v) {
            this.i.fi = +v;
        },
        enumerable: false,
        configurable: true
    });
    IgrToolActionIconButton.prototype.cleanUp = function () {
        this.i.dd();
    };
    IgrToolActionIconButton.prototype.openSubMenu = function () {
        this.i.d1();
    };
    IgrToolActionIconButton.prototype.closeSubmenu = function () {
        this.i.df();
    };
    IgrToolActionIconButton.prototype.fromInfo = function (info) {
        this.i.dp(info);
    };
    return IgrToolActionIconButton;
}(IgrToolAction));
export { IgrToolActionIconButton };
