/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { Base, markType, INotifyPropertyChanged_$type, PropertyChangedEventArgs, runOn, delegateCombine, enumGetBox, typeCast, delegateRemove, fromEn, EnumUtil } from "igniteui-react-core";
import { RenderingContext } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { ToolPanel } from "./ToolPanel";
import { DOMExecutionContext } from "igniteui-react-core";
import { CanvasViewRenderer } from "igniteui-react-core";
import { Size } from "igniteui-react-core";
import { NativeUI } from "igniteui-react-core";
import { FontUtil } from "igniteui-react-core";
import { ICommandStateChangedListener_$type } from "igniteui-react-core";
import { SRProvider } from "igniteui-react-core";
import { BaseControlTheme_$type } from "igniteui-react-core";
import { ToolActionCollection } from "./ToolActionCollection";
import { ToolbarOrientation_$type } from "./ToolbarOrientation";
import { ToolbarIconManager } from "./ToolbarIconManager";
import { ToolAction } from "./ToolAction";
import { NativeUIInputsFactory } from "igniteui-react-core";
import { NativeUIXInputsFactory } from "igniteui-react-inputs";
import { Visibility_$type } from "igniteui-react-core";
import { stringIsNullOrEmpty } from "igniteui-react-core";
/**
 * @hidden
 */
var ToolbarView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ToolbarView, _super);
    function ToolbarView() {
        var _this = _super.call(this) || this;
        _this.n = null;
        _this.m = null;
        _this.a = null;
        _this.i = null;
        _this.l = null;
        _this.e = null;
        _this.k = null;
        _this.b = ((function () {
            var $ret = new FontInfo();
            $ret.n = "Verdana";
            $ret.d = 13;
            $ret.q = "Normal";
            $ret.s = "Normal";
            $ret.o = "Normal";
            return $ret;
        })());
        _this.aa = new Size();
        _this.c = null;
        _this._gridExternal = null;
        _this.f = false;
        _this.j = null;
        return _this;
    }
    ToolbarView.prototype.p = function () {
        return this.i;
    };
    ToolbarView.prototype.v = function () {
    };
    ToolbarView.prototype.t = function (a) {
        if (a == null) {
            this.i = null;
            return;
        }
        this.a.a = new DOMExecutionContext(a);
        this.i = a;
        this.l = this.i.createElement("canvas");
        this.e = new RenderingContext(new CanvasViewRenderer(), this.i.get2DCanvasContext(this.l));
        this.k = this.i.createElement("div");
        this.y();
        var b = new ToolPanel();
        var c = this.i.createElement("div");
        c.setStyleProperty("width", "100%");
        c.setStyleProperty("height", "100%");
        this.i.append(c);
        var d = this.i.getSubRenderer(c);
        b.provideContainer(d);
        var e = this.i.getExternal(b, this.i.rootWrapper, this.i.getExternal(this.a, null, null));
        this.a.b2(b);
        var f = Math.round(a.rootWrapper.width());
        var g = Math.round(a.rootWrapper.height());
        this.i.rootWrapper.setStyleProperty("position", "relative");
    };
    ToolbarView.prototype.y = function () {
    };
    ToolbarView.prototype.x = function () {
        if (this.i != null) {
        }
    };
    ToolbarView.prototype.s = function () {
        if (this.i == null) {
            return;
        }
        var a = this.i.rootWrapper.width();
        var b = this.i.rootWrapper.height();
        this.aa = new Size(1, a, b);
        this.a.b5(this.aa);
    };
    ToolbarView.prototype.z = function () {
        var a = this.i;
        if (null == a) {
            return;
        }
        var b = a.rootWrapper;
        if (null != b) {
            NativeUI.p(b, this.a.cz);
            NativeUI.l(b, this.a.cq);
        }
    };
    ToolbarView.prototype.d = function () {
        return this.b;
    };
    ToolbarView.prototype.u = function () {
    };
    ToolbarView.prototype.w = function () {
    };
    ToolbarView.prototype.r = function () {
    };
    ToolbarView.prototype.g = function () {
        return this.aa.width;
    };
    ToolbarView.prototype.h = function (a) {
        this.c = this.a.s();
        return FontUtil.measureStringWidth(a, this.c, this.e);
    };
    ToolbarView.prototype.q = function (a, b) {
        if (this.j == null) {
            this.j = this.i.createElement("div");
        }
        b(this.j.getNativeElement());
    };
    ToolbarView.$t = markType(ToolbarView, 'ToolbarView');
    return ToolbarView;
}(Base));
export { ToolbarView };
/**
 * @hidden
 */
var Toolbar = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Toolbar, _super);
    function Toolbar() {
        var _this = _super.call(this) || this;
        _this.k = null;
        _this.v = false;
        _this.t = null;
        _this.m = null;
        _this.n = 0;
        _this.d = new ToolActionCollection();
        _this.b = new ToolActionCollection();
        _this.c = new ToolActionCollection();
        _this.h = Toolbar.i;
        _this.p = null;
        _this.av = Toolbar.aw;
        _this.ce = null;
        _this.cm = null;
        _this.cg = null;
        _this.cl = null;
        _this.ci = null;
        _this.cn = null;
        _this.cf = null;
        _this.ch = null;
        _this.cp = null;
        _this.co = null;
        _this.aj = NaN;
        _this.ak = NaN;
        _this.cj = null;
        _this.ck = null;
        _this.q = null;
        _this.ag = NaN;
        _this.ah = NaN;
        _this.ai = NaN;
        _this.af = NaN;
        _this.ac = NaN;
        _this.ad = NaN;
        _this.ae = NaN;
        _this.ab = NaN;
        _this.x = true;
        _this.w = false;
        _this.propertyChanged = null;
        _this.a = null;
        _this.onCommand = null;
        ToolbarIconManager.c();
        var a = _this.actions;
        a.collectionChanged = delegateCombine(a.collectionChanged, runOn(_this, _this.bu));
        var b = _this.actualActions;
        b.collectionChanged = delegateCombine(b.collectionChanged, runOn(_this, _this.bw));
        var c = _this.actualActions;
        c.collectionResetting = delegateCombine(c.collectionResetting, runOn(_this, _this.bx));
        NativeUIInputsFactory.n();
        NativeUIXInputsFactory.j();
        var d = new ToolbarView();
        d.a = _this;
        _this.k = d;
        _this.k.v();
        return _this;
    }
    Object.defineProperty(Toolbar.prototype, "u", {
        get: function () {
            if (this.t == null) {
                this.t = new SRProvider(this.k.i);
                this.t.cb("Layouts");
            }
            return this.t;
        },
        enumerable: false,
        configurable: true
    });
    Toolbar.prototype.b2 = function (a) {
        this.m = a;
        this.m.r = this.n == 0 ? 1 : this.n;
        var b = this.m;
        b.onCommand = delegateCombine(b.onCommand, runOn(this, this.bt));
        this.m.o = this.j;
        this.m.ac = this.aa;
        this.m.fh = this.cz;
        this.m.e8 = this.cr;
        this.m.e7 = this.cq;
        this.m.fg = this.cy;
        this.m.e9 = this.cs;
        this.m.fb = this.ct;
        this.m.ff = this.cx;
        this.m.fc = this.cu;
        this.m.fj = this.c1;
        this.m.fi = this.c0;
        this.m.bl = this.at;
        this.m.bm = this.au;
        this.m.fd = this.cv;
        this.m.fe = this.cw;
        this.m.be = this.am;
        this.m.bf = this.an;
        this.m.bg = this.ao;
        this.m.bd = this.al;
        this.m.bi = this.aq;
        this.m.bj = this.ar;
        this.m.bk = this.as;
        this.m.bh = this.ap;
    };
    Toolbar.prototype.bt = function (a, b) {
        if (this.onCommand != null) {
            this.onCommand(this, b);
        }
        if (this.p != null) {
            this.p.onToolCommandExecuting(b.a);
        }
    };
    Toolbar.prototype.b5 = function (a) {
        this.m.notifySizeChanged();
    };
    Object.defineProperty(Toolbar.prototype, "o", {
        get: function () {
            return this.n;
        },
        set: function (a) {
            var b = this.n;
            this.n = a;
            if (b != this.n) {
                this.b6("BaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, a));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "autoGeneratedActions", {
        get: function () {
            return this.d;
        },
        set: function (a) {
            var b = this.d;
            this.d = a;
            if (b != this.d) {
                this.b6("AutoGeneratedActions", b, this.d);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "actions", {
        get: function () {
            return this.b;
        },
        set: function (a) {
            var b = this.b;
            this.b = a;
            if (b != this.b) {
                this.b6("Actions", b, this.b);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "actualActions", {
        get: function () {
            return this.c;
        },
        set: function (a) {
            var b = this.c;
            this.c = a;
            if (b != this.c) {
                this.b6("ActualActions", b, this.c);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "j", {
        get: function () {
            return this.h;
        },
        set: function (a) {
            var b = this.h;
            this.h = a;
            if (b != this.h) {
                this.b6("Orientation", enumGetBox(ToolbarOrientation_$type, b), enumGetBox(ToolbarOrientation_$type, a));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "target", {
        get: function () {
            return this.av;
        },
        set: function (a) {
            var b = this.av;
            this.av = a;
            if (b != this.av) {
                this.b6("Target", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "cq", {
        get: function () {
            return this.ce;
        },
        set: function (a) {
            var b = this.ce;
            this.ce = a;
            if (b != this.ce) {
                this.b6("BackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "cy", {
        get: function () {
            return this.cm;
        },
        set: function (a) {
            var b = this.cm;
            this.cm = a;
            if (b != this.cm) {
                this.b6("SubmenuBackgroundColor", b, this.cm);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "cs", {
        get: function () {
            return this.cg;
        },
        set: function (a) {
            var b = this.cg;
            this.cg = a;
            if (b != this.cg) {
                this.b6("GroupHeaderBackgroundColorPropertyName", b, this.cg);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "cx", {
        get: function () {
            return this.cl;
        },
        set: function (a) {
            var b = this.cl;
            this.cl = a;
            if (b != this.cl) {
                this.b6("SeparatorBackgroundColor", b, this.cl);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "cu", {
        get: function () {
            return this.ci;
        },
        set: function (a) {
            var b = this.ci;
            this.ci = a;
            if (b != this.ci) {
                this.b6("HoverBackgroundColor", b, this.ci);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "cz", {
        get: function () {
            return this.cn;
        },
        set: function (a) {
            var b = this.cn;
            this.cn = a;
            if (b != this.cn) {
                this.b6("TextColor", b, this.cn);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "cr", {
        get: function () {
            return this.cf;
        },
        set: function (a) {
            var b = this.cf;
            this.cf = a;
            if (b != this.cf) {
                this.b6("DisabledTextColor", b, this.cf);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "ct", {
        get: function () {
            return this.ch;
        },
        set: function (a) {
            var b = this.ch;
            this.ch = a;
            if (b != this.ch) {
                this.b6("GroupHeaderTextColor", b, this.ch);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "c1", {
        get: function () {
            return this.cp;
        },
        set: function (a) {
            var b = this.cp;
            this.cp = a;
            if (b != this.cp) {
                this.b6("ToolTipTextColor", b, this.cp);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "c0", {
        get: function () {
            return this.co;
        },
        set: function (a) {
            var b = this.co;
            this.co = a;
            if (b != this.co) {
                this.b6("ToolTipBackgroundColor", b, this.co);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "at", {
        get: function () {
            return this.aj;
        },
        set: function (a) {
            var b = this.aj;
            this.aj = a;
            if (b != this.aj) {
                this.b6("ToolTipCornerRadius", b, this.aj);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "au", {
        get: function () {
            return this.ak;
        },
        set: function (a) {
            var b = this.ak;
            this.ak = a;
            if (b != this.ak) {
                this.b6("ToolTipElevation", b, this.ak);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "cv", {
        get: function () {
            return this.cj;
        },
        set: function (a) {
            var b = this.cj;
            this.cj = a;
            if (b != this.cj) {
                this.b6("IconFill", b, this.cj);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "cw", {
        get: function () {
            return this.ck;
        },
        set: function (a) {
            var b = this.ck;
            this.ck = a;
            if (b != this.ck) {
                this.b6("IconStroke", b, this.ck);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "r", {
        get: function () {
            return this.q;
        },
        set: function (a) {
            var b = this.q;
            this.q = a;
            if (b != this.q) {
                this.b6("CellTextStyle", b, this.q);
            }
        },
        enumerable: false,
        configurable: true
    });
    Toolbar.prototype.s = function () {
        if (this.r == null) {
            return this.k.d();
        }
        return this.r;
    };
    Object.defineProperty(Toolbar.prototype, "aq", {
        get: function () {
            return this.ag;
        },
        set: function (a) {
            var b = this.ag;
            this.ag = a;
            if (b != this.ag) {
                this.b6("SeparatorVerticalPaddingLeft", b, this.ag);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "ar", {
        get: function () {
            return this.ah;
        },
        set: function (a) {
            var b = this.ah;
            this.ah = a;
            if (b != this.ah) {
                this.b6("SeparatorVerticalPaddingRight", b, this.ah);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "as", {
        get: function () {
            return this.ai;
        },
        set: function (a) {
            var b = this.ai;
            this.ai = a;
            if (b != this.ai) {
                this.b6("SeparatorVerticalPaddingTop", b, this.ai);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "ap", {
        get: function () {
            return this.af;
        },
        set: function (a) {
            var b = this.af;
            this.af = a;
            if (b != this.af) {
                this.b6("SeparatorVerticalPaddingBottom", b, this.af);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "am", {
        get: function () {
            return this.ac;
        },
        set: function (a) {
            var b = this.ac;
            this.ac = a;
            if (b != this.ac) {
                this.b6("SeparatorHorizontalPaddingLeft", b, this.ac);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "an", {
        get: function () {
            return this.ad;
        },
        set: function (a) {
            var b = this.ad;
            this.ad = a;
            if (b != this.ad) {
                this.b6("SeparatorHorizontalPaddingRight", b, this.ad);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "ao", {
        get: function () {
            return this.ae;
        },
        set: function (a) {
            var b = this.ae;
            this.ae = a;
            if (b != this.ae) {
                this.b6("SeparatorHorizontalPaddingTop", b, this.ae);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "al", {
        get: function () {
            return this.ab;
        },
        set: function (a) {
            var b = this.ab;
            this.ab = a;
            if (b != this.ab) {
                this.b6("SeparatorHorizontalPaddingBottom", b, this.ab);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "aa", {
        get: function () {
            return this.x;
        },
        set: function (a) {
            var b = this.x;
            this.x = a;
            if (b != this.x) {
                this.b6("ShowOnHover", b, this.x);
            }
        },
        enumerable: false,
        configurable: true
    });
    Toolbar.prototype.bu = function (a, b) {
        var e_1, _a, e_2, _b;
        if (b.oldItems != null) {
            try {
                for (var _c = __values(fromEn(b.oldItems)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var c = _d.value;
                    if (typeCast(INotifyPropertyChanged_$type, c) !== null) {
                        var d = c;
                        d.propertyChanged = delegateRemove(d.propertyChanged, runOn(this, this.bv));
                    }
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
        }
        if (b.newItems != null) {
            try {
                for (var _e = __values(fromEn(b.newItems)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var e = _f.value;
                    if (typeCast(INotifyPropertyChanged_$type, e) !== null) {
                        var f = e;
                        f.propertyChanged = delegateCombine(f.propertyChanged, runOn(this, this.bv));
                    }
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
        }
        this.b4();
    };
    Toolbar.prototype.bw = function (a, b) {
        this.cd();
    };
    Toolbar.prototype.bx = function (a, b) {
        for (var c = 0; c < this.actualActions.count; c++) {
            if (typeCast(INotifyPropertyChanged_$type, this.actualActions._inner[c]) !== null) {
                var d = this.actualActions._inner[c];
                d.propertyChanged = delegateRemove(d.propertyChanged, runOn(this, this.bv));
            }
            this.actualActions._inner[c].b = null;
        }
    };
    Toolbar.prototype.cd = function () {
        var a = this.o == 0 ? 1 : this.o;
        if (this.m != null) {
            this.m.r = a;
        }
        for (var b = 0; b < this.actualActions.count; b++) {
            this.actualActions._inner[b].l = a;
        }
    };
    Toolbar.prototype.bv = function (a, b) {
    };
    Toolbar.prototype.b4 = function () {
        this.ca();
    };
    Toolbar.prototype.ca = function () {
        if (this.w) {
            return;
        }
        this.w = true;
        this.a.enqueueAction(runOn(this, this.b0));
    };
    Toolbar.prototype.b0 = function () {
        if (!this.w) {
            return;
        }
        this.w = false;
        this.cb();
        if (this.m.actions != this.actualActions) {
            this.m.actions = this.actualActions;
        }
    };
    Toolbar.prototype.cb = function () {
        var _this = this;
        this.actualActions.clear();
        for (var a = 0; a < this.autoGeneratedActions.count; a++) {
            this.actualActions.add(this.autoGeneratedActions._inner[a]);
        }
        var b = null;
        var c = null;
        var d = false;
        var e = false;
        var f = -1;
        var g = 0;
        var _loop_1 = function (h) {
            var i = this_1.actions._inner[h];
            if (!stringIsNullOrEmpty(i.cw)) {
                if (((function () { var j = _this.y(i.cw, _this.actualActions, b, f); b = j.p2; f = j.p3; return j.ret; })())) {
                    b._inner[f].d2(i);
                }
            }
            else {
                if (!stringIsNullOrEmpty(i.b9)) {
                    if (i.d != null) {
                        i.d.actions.remove(i);
                    }
                    if (((function () { var j = _this.y(i.b9, _this.actualActions, b, f); b = j.p2; f = j.p3; return j.ret; })())) {
                        c = i.b9;
                        d = true;
                        e = false;
                    }
                }
                else if (!stringIsNullOrEmpty(i.b6)) {
                    if (i.d != null) {
                        i.d.actions.remove(i);
                    }
                    if (((function () { var j = _this.y(i.b6, _this.actualActions, b, f); b = j.p2; f = j.p3; return j.ret; })())) {
                        c = i.b6;
                        d = false;
                        e = true;
                        g = 0;
                    }
                }
                if (!stringIsNullOrEmpty(c)) {
                    if (d) {
                        b.insert(f, i);
                        f++;
                    }
                    else if (e) {
                        b.insert(f + 1 + g, i);
                        g++;
                    }
                }
                else {
                    this_1.actualActions.add(i);
                }
            }
        };
        var this_1 = this;
        for (var h = 0; h < this.actions.count; h++) {
            _loop_1(h);
        }
    };
    Toolbar.prototype.y = function (a, b, c, d) {
        var _this = this;
        var _loop_2 = function (e) {
            var f = b._inner[e];
            if (f.cu != null && f.cu == a) {
                c = b;
                d = e;
                return { value: {
                        ret: true,
                        p2: c,
                        p3: d
                    } };
            }
            if (f.actions.count > 0) {
                if (((function () { var g = _this.y(a, f.actions, c, d); c = g.p2; d = g.p3; return g.ret; })())) {
                    return { value: {
                            ret: true,
                            p2: c,
                            p3: d
                        } };
                }
            }
        };
        for (var e = 0; e < b.count; e++) {
            var state_1 = _loop_2(e);
            if (typeof state_1 === "object")
                return state_1.value;
        }
        c = c;
        d = d;
        return {
            ret: false,
            p2: c,
            p3: d
        };
    };
    Toolbar.prototype.z = function (a, b, c, d) {
        var _this = this;
        var _loop_3 = function (e) {
            var f = b._inner[e];
            if (f.cd == null) {
                if (f.cu != null && f.cu == a) {
                    c = b;
                    d = e;
                    return { value: {
                            ret: true,
                            p2: c,
                            p3: d
                        } };
                }
            }
            else if (f.cd != null && f.cd == a) {
                c = b;
                d = e;
                return { value: {
                        ret: true,
                        p2: c,
                        p3: d
                    } };
            }
            if (f.actions.count > 0) {
                if (((function () { var g = _this.y(a, f.actions, c, d); c = g.p2; d = g.p3; return g.ret; })())) {
                    return { value: {
                            ret: true,
                            p2: c,
                            p3: d
                        } };
                }
            }
        };
        for (var e = 0; e < b.count; e++) {
            var state_2 = _loop_3(e);
            if (typeof state_2 === "object")
                return state_2.value;
        }
        c = c;
        d = d;
        return {
            ret: false,
            p2: c,
            p3: d
        };
    };
    Toolbar.prototype.b1 = function () {
        if (this.w) {
            this.b0();
        }
    };
    Toolbar.prototype.notifySizeChanged = function () {
        this.k.s();
    };
    Toolbar.prototype.destroy = function () {
        this.provideContainer(null);
    };
    Toolbar.prototype.provideContainer = function (a) {
        this.k.t(a);
    };
    Toolbar.prototype.b6 = function (a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        this.b8(a, b, c);
    };
    Toolbar.prototype.b8 = function (a, b, c) {
        switch (a) {
            case "CellTextStyle":
                this.ca();
                break;
            case "BackgroundColor":
            case "TextColor":
            case "SubmenuBackgroundColor":
            case "GroupHeaderBackgroundColorPropertyName":
            case "GroupHeaderTextColor":
            case "SeparatorBackgroundColor":
            case "HoverBackgroundColor":
            case "IconFill":
            case "IconStroke":
            case "ToolTipTextColor":
            case "ToolTipBackgroundColor":
            case "ToolTipCornerRadius":
            case "ToolTipElevation":
            case "Orientation":
            case "ShowOnHover":
                this.cc();
                break;
            case "Target":
                var d = c;
                var e = b;
                this.b7(e, d);
                break;
            case "BaseTheme":
                this.cd();
                break;
        }
    };
    Toolbar.prototype.cc = function () {
        if (this.m != null) {
            this.m.ac = this.aa;
            this.m.e7 = this.cq;
            this.m.fh = this.cz;
            this.m.e8 = this.cr;
            this.m.fg = this.cy;
            this.m.e9 = this.cs;
            this.m.fb = this.ct;
            this.m.ff = this.cx;
            this.m.fc = this.cu;
            this.m.o = this.j;
            this.m.fj = this.c1;
            this.m.fi = this.c0;
            this.m.bl = this.at;
            this.m.bm = this.au;
            this.m.fd = this.cv;
            this.m.fe = this.cw;
            this.m.be = this.am;
            this.m.bf = this.an;
            this.m.bg = this.ao;
            this.m.bd = this.al;
            this.m.bi = this.aq;
            this.m.bj = this.ar;
            this.m.bk = this.as;
            this.m.bh = this.ap;
        }
    };
    Toolbar.prototype.b7 = function (a, b) {
        this.p = b;
        if (a != null) {
            this.autoGeneratedActions.clear();
            a.removeCommandStateChangedListener(this);
            this.ca();
        }
        if (b != null) {
            this.autoGeneratedActions.clear();
            var c = b.getDesiredToolbarActions();
            if (c != null) {
                for (var d = 0; d < c.length; d++) {
                    var e = ToolAction.c(c[d]);
                    this.autoGeneratedActions.add(e);
                }
            }
            b.addCommandStateChangedListener(this);
            this.ca();
        }
    };
    Toolbar.prototype.by = function () {
        if (this.m != null) {
            this.m.dc();
        }
    };
    Toolbar.prototype.onCommandStateChanged = function (a, b, c) {
        var _this = this;
        var d = null;
        var e = -1;
        if (((function () { var f = _this.z(a, _this.actualActions, d, e); d = f.p2; e = f.p3; return f.ret; })())) {
            var f = d._inner[e];
            switch (b) {
                case 2:
                    switch (f.m) {
                        case 2:
                            f.e3 = c;
                            break;
                        case 5:
                            f.e4 = c;
                            break;
                        case 6:
                            f.e3 = c;
                            break;
                    }
                    break;
                case 0:
                    f.e0 = EnumUtil.getEnumValue(Visibility_$type, c);
                    break;
                case 1:
                    f.ah = c;
                    break;
            }
        }
    };
    Toolbar.$t = markType(Toolbar, 'Toolbar', Base.$, [INotifyPropertyChanged_$type, ICommandStateChangedListener_$type]);
    Toolbar.i = 1;
    Toolbar.aw = null;
    return Toolbar;
}(Base));
export { Toolbar };
